<?php 
//  Proje:   Google Analystic Export Script         //
//  Site :   http://www.TEAkolik.com                //
//  Yazar:   Hamza ŞAMLIOĞLU                        //
//  Script:  Sergej Müller                          //
//  File:    Chart.class.php                        //
//  Versiyon:   2.0                                 //


class chart {
	public static function export($data) {
		$query = self::line($data);
		$url = 'http://chart.apis.google.com/chart?' . http_build_query($query);
		echo sprintf(
		             '<a href="#id=%s"><img src="%s" alt="Report  %s" /></a>',
		             $data['query']['id'],
		             $url,
	             $data['query']['chtt']
		            );
	}
	
	public static function line($data) {
		$max = self::maxElement($data['values']);
		$alpha = 4095 / (float)$max;
		$data['values'] = self::normalize($data['values'], $alpha);
		for($i = 0, $size = count($data['values']); $i < $size; $i++) {
		  $values[$i] = implode('', self::encodeData($data['values'][$i]));
		}
		$data['query']['chd'] = 'e:' . implode(',', $values);
		$data['query']['chd'] .= ',AAAA';
		$labelsCount = count($data['labels']);
		$labels = array(
			$data['labels'][0],
			$data['labels'][($labelsCount-1)/4],
			$data['labels'][($labelsCount-1)/2],
			$data['labels'][($labelsCount-1)/4*3],
			$data['labels'][$labelsCount-1]
		);
		$data['query']['chxl'] = '0:|' .implode('|', $labels);
		$data['query']['chxr'] = '1,1,' .$max;
		return $data['query'];
	}
	
	private static function extEncode($dec) {
		if ($dec === false) {
			return '__';
		}
		$e = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-.';
		$m = strlen($e);
		$res = '';
		do {
			$r = $dec % $m;
			$dec = (int)((int)$dec / (int)$m);
			$res = $e[$r] . $res;
		} while($dec > 0);
		$res = sprintf("%'A2s", $res);
		return $res;
	}
	
	private static function maxElement($a) {
		$max = 0;
		foreach ($a as $el) {
			if (is_array($el)) {
				$el = self::maxElement($el);
		  }
			if ($el > $max) {
				$max = $el;
			}
		}
		return $max;
	}
	
	private static function normalize($a, $alpha) {
		foreach($a as &$el) {
			if (is_array($el)) {
			  $el = self::normalize($el, $alpha);
			} else {
			  $el = (int)($el * $alpha);
			}
		}
		return $a;
	}
	
	private static function encodeData($a) {
		return array_map(array('chart', 'extEncode'), $a);
	}
}